#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <pvm3.h>
#include "const.h"    
#include "tetris.h"

int PocetStack[5];
THra HraStack[5];
TTah TahyStack[5][100];
int JOB[10],best,bestj;

void Srot(int co){
  int i,hodn;
  
  // porobime si mozne tahy pre aktualnu hru
  HraStack[co].this=JOB[co];
  HraStack[co].thisr=HraStack[co].thisc=0;
  NajdiTahy(&HraStack[co],&PocetStack[co],TahyStack[co]);

  // kazdy z nich vyskusame
  for (i=0;i<PocetStack[co];i++) {
    memcpy(&HraStack[co+1],&HraStack[co],sizeof(THra));
    HraStack[co+1].this=JOB[co]; HraStack[co+1].next=JOB[co+1];
    HraStack[co+1].thisr=HraStack[co+1].thisc=0;
    SpravTah(&HraStack[co+1],TahyStack[co][i]);

    if (co==(HLBKA_BT+HLBKA_BT2)) {
      hodn=HodnotHru(&HraStack[co+1]);
      if (hodn>bestj) bestj=hodn;
    } else {
      // ideme sa hlbsie vnorit
      Srot(co+1);
    }
  }
}

void SrotJob(int kery){
  int i;
  for (i=0;i<7;i++) {
    JOB[HLBKA_BT+kery]=4*i;
    if (kery==HLBKA_BT2) {
      bestj=-20000;
      Srot(0); 
      if (bestj<best) best=bestj;
    } else SrotJob(kery+1);
  }
}

int main() {
  int ParentovTID, MojeCislo, msgtag,bufid,msglen,CisloTahu,i;
  char hostname[100];
  
  // prve volanie pvm_* funkcie nas pripoji do masiny; zistime si rodica 
  ParentovTID=pvm_parent();

  // rodic nam MojeCislole poradove cislo 
  pvm_recv(ParentovTID,MSG_ENROLL);
  pvm_upkint(&MojeCislo,1,1);

  // MojeCisloleme naspat stroj, na ktorom bezime 
  gethostname(hostname,100);
  pvm_initsend(PvmDataDefault);
  pvm_pkint(&MojeCislo,1,1);
  pvm_pkstr(hostname);
  pvm_send(ParentovTID,MSG_ACK);

  while(1) {
    // cakame na spravu od rodica, moze to byt REQUEST alebo CLOSE
    bufid = pvm_recv(ParentovTID,-1);
    // ak sme dostali CLOSE, koncime 
    pvm_bufinfo(bufid,&msglen,&msgtag,&ParentovTID);
    if (msgtag==MSG_CLOSE) break;
    // precitame si zadanie 
    pvm_upkint(&CisloTahu,1,1);
    for (i=0;i<=HLBKA_BT;i++) pvm_upkint(&JOB[i],1,1);
    for (i=0;i<=HLBKA_BT;i++) JOB[i]*=4;
    pvm_upkbyte(&HraStack[0].Plan[0][0],50*25,1);
    pvm_upkint(&HraStack[0].R,1,1); 
    pvm_upkint(&HraStack[0].C,1,1);
    pvm_upkint(&HraStack[0].score,1,1);
    HraStack[0].thisr=HraStack[0].thisc=0;
 
    // ideme pocitat
    best=470000000; bestj=-20000;
    if (HLBKA_BT2) {
      // vyskusame vsetkymi sposobmi doplnit joby, zakazdym zavolame Srot
      SrotJob(1);
    } else {
      Srot(0);
      best=bestj;
    }
    
    // posleme najlepsi najdeny vysledok
    pvm_packf("%+ %d %d %d",PvmDataDefault,MojeCislo,CisloTahu,best);
    pvm_send(ParentovTID,MSG_REPLY);
  }
  return 0;
}
